<?php
error_reporting(E_ERROR || E_WARNING);
ini_set('display_errors', '1');

require_once 'parserNew.php';

function printStats($name, $property) {
	$stats = stats($name);
	echo "$name" . " " . count($stats);
	echo "<table class='stats'>\n";
	$i = 0;
	foreach ($stats as $key => $item) {
		if ($i > 60 or $item < 2) break;
		$link = '<a href="movies.php?name=' . $key . '&item=' . $property . '">' . $key . "</a>";
		echo <<<END
		<tr>
		<td class='item'>$link</td><td class='value'>$item</td>
		</tr>
		
END;
		$i++;
	}
	echo "</table>\n";
}

function printSeenStats($name, $property) {
	$stats = statsSeen($name);
	echo "$name" . " " . count($stats);
	echo "<table class='stats'>\n";
	$i = 0;
	foreach ($stats as $key => $item) {
		if ($i > 60 or $item < 2) break;
		$link = '<a href="movies.php?name=' . $key . '&item=' . $property . '">' . $key . "</a>";
		echo <<<END
		<tr>
		<td class='item'>$link</td><td class='value'>$item</td>
		</tr>
		
END;
		$i++;
	}
	echo "</table>\n";
}

function printRatingStats($name, $property) {
	$stats = statsRatings($name);
	echo "$name" . " " . count($stats);
	echo "<table class='stats'>\n";
	$i = 0;
	foreach ($stats as $key => $item) {
		if ($i > 60 or $item < 2) break;
		$link = '<a href="movies.php?name=' . $key . '&item=' . $property . '">' . $key . "</a>";
		echo <<<END
		<tr>
		<td class='item'>$link</td><td class='value'>$item</td>
		</tr>
		
END;
		$i++;
	}
	echo "</table>\n";
}

function printResolutionStats($name, $property) {
	$stats = statsResolution($name);
	echo "$name" . " " . count($stats);
	echo "<table class='stats'>\n";
	$i = 0;
	foreach ($stats as $key => $item) {
		if ($i > 40)
			break;
		$link = '<a href="movies.php?name=' . $key . '&item=' . $property . '">' . $key . "</a>";
		echo <<<END
		<tr>
		<td class='item' style="text-align: right">$link</td><td class='value'>$item</td>
		</tr>
		
END;
		$i++;
	}
	echo "</table>\n";
}

function printLocationStats($name, $property) {
	$stats = statsLocation($name);
	echo "$name" . " " . count($stats);
	echo "<table class='stats'>\n";
	$i = 0;
	foreach ($stats as $key => $item) {
		if ($i > 40)
			break;
		$link = '<a href="movies.php?name=' . $key . '&item=' . $property . '">' . $key . "</a>";
		echo <<<END
		<tr>
		<td class='item'>$link</td><td class='value'>$item</td>
		</tr>
		
END;
		$i++;
	}
	echo "</table>\n";
}

function printMore() {
	echo "<table id='stats'>\n<tr>";

	echo "<td valign='top'>\n";
	printStats("Years", 'movieYear');
	echo "</td>\n";

	echo "<td valign='top'>\n";
	printRatingStats("Ratings", 'movieRating');
	echo "</td>\n";

	echo "<td valign='top'>\n";
	printStats("Media", 'movieMediaType');
	echo "</td>\n";

	echo "<td valign='top'>\n";
	printResolutionStats("Resolution", 'movieResolution');
	echo "</td>\n";

	echo "<td valign='top'>\n";
	printLocationStats("Location", 'movieLocation');
	echo "</td>\n";

	echo "<td valign='top'>\n";
	printStats("Dates", 'movieDate');
	echo "</td>\n";

	echo "<td valign='top'>\n";
	printStats("Seen", 'movieSeen');
	echo "</td>\n";

	echo "</tr>\n</table>";
}

function printMany() {
	echo "<table id='stats'>\n<tr>";

	echo "<td valign='top'>\n";
	printStats("Directors", 'movieDirector');
	echo "</td>\n";

	echo "<td valign='top'>\n";
	printStats("Actors", 'movieActors');
	echo "</td>\n";

	echo "<td valign='top'>\n";
	printStats("Categories", 'movieCategory');
	echo "</td>\n";

	echo "<td valign='top'>\n";
	printStats("Countries", 'movieCountry');
	echo "</td>\n";

	echo "</tr>\n</table>";
}

function printHelp() {
	$films = count($_SESSION['lists']->Movies);
	$session = ($_SESSION['fresh'] == 0) ? "old session" : "new session";
	echo <<<END
				<h1>Film Collection</h1>
				<h2>Top menu bar</h2>
				<p>Click on <em>All Films</em> to load film pictures or <em>Directors</em>,
					<em>Categories</em>, etc. for the corresponding list. 
					<em>Help</em> displays this page. 
					Use the <em>search box</em> to find films.</p>
				<h2>Bottom menu bar</h2>
				<p><em>Expand</em> or <em>Contract</em> the picture area. 
					Select picture <em>size</em>.
					Select <em>Grouping</em> of films in picture area</p>
				<h2>Picture area on the left</h2>
				<p>Load film pictures from the menu. Click on a picture for film details.</p>
				<h2>Statistics</h2>
				<p>$films films ($session)</p>
						
END;
}
?>
<!DOCTYPE html>
<html lang="en">
	<head>
		<title>Help</title>
		<meta charset="utf-8" />
		<meta http-equiv="X-UA-Compatible" content="IE=9" >
		<meta name="robots" content="index, follow" />
		<link rel="stylesheet" href="default.css" type="text/css" />
		<script type="text/javascript" src="//ajax.googleapis.com/ajax/libs/mootools/1.4.5/mootools-yui-compressed.js"></script>
		<script type="text/javascript" src="mootools-more-1.4.0.1.js"></script>
		<script>
			window.addEvent('domready', function() {
				$('more').addEvent('click', function(event) {
					event.stop();
					if (this.getProperty('text') === 'Next') {
						$('statsdiv1').setStyle('display', 'none');
						$('statsdiv2').setStyle('display', 'block');
						this.setProperty('text', 'Previous');	
					} else {
						$('statsdiv1').setStyle('display', 'block');
						$('statsdiv2').setStyle('display', 'none');
						this.setProperty('text', 'Next');		
					}
				});
			});
		</script>
		<style>
		</style>
	</head>
	<body>
		<div id="intro">
<?php printHelp(); ?>
			<div id="morediv">
				<button id="more">Next</button>
			</div>
			<div id="statsdiv1">
<?php printMany(); ?>	
			</div>
			<div id="statsdiv2" style="display: none;">
<?php printMore(); ?>	
			</div>
		</div>
	</body>
</html>