<?php
error_reporting(E_ERROR || E_WARNING);
ini_set('display_errors', '1');

require_once 'parserNew.php';

$hidden = (ip_is_private($_SERVER['REMOTE_ADDR'])) ? "" : "display:none";

?>
<!DOCTYPE html>
<html lang="en">
	<head>
		<title>ANT Movies</title>
		<?php require 'head.php'; ?>
		<script type="text/javascript" src="main.js"></script>
	</head>
	<body>
		<div id="container">
			<div id="disabled"></div>
			<div id="header">
				<div id="menu">
					<ul>
						<li id ="label"></li>
						<li><a class="all" id="all" rel="All Films" title="Όλες οι ταινίες" href="movies.php">All Films</a></li>
						<li><a class="tonav" id="directors" rel="Directors" title="Σκηνοθέτες" href="list.php?item=Directors">Directors</a></li>
						<li><a class="tonav" id="actors" rel="Actors" title="Ηθοποιοί" href="list.php?item=Actors">Actors</a></li>
						<li><a class="tonav" id="categories" rel="Categories" title="Κατηγορίες" href="list.php?item=Categories">Categories</a></li>
						<li><a class="tonav" id="countries" rel="Countries" title="Χώρες" href="list.php?item=Countries">Countries</a></li>
						<li><a class="tonav" id="years" rel="Years" title="Έτη" href="list.php?item=Years">Years</a></li>
						<li><a class="tonav" id="ratings" rel="Ratings" title="Βαθμολογίες" href="list.php?item=Ratings">Ratings</a></li>
						<li><a class="tonav" id="dates" rel="Dates" title="Ημερομηνίες καταχώρησης" href="list.php?item=Dates">Dates</a></li>
						<li><a class="tonav" id="media" rel="Media" title="Μέσα" href="list.php?item=Media">Media</a></li>
						<li><a id="menuHelp" title="Βοήθεια/Στατιστικές" href="help.php">Help/Stats</a></li>
					</ul>
				</div>
				<div id="search">
					<form id="searchform" method="get" action="movies.php" >
						<input type="submit" value="Search in" id="searchbutton" title="Ανεύρεση σε" >
						<select name="where" id="where">
							<option value="movieFormattedTitle">Titles</option>
							<option value="movieDirector">Directors</option>
							<option value="movieActors">Actors</option>
						</select>
						<input type="text"name="search" size="10" id="searchstring">
					</form>
				</div>
			</div>
			<div id="leftpane">
				<div id="list"></div>
				<div id="slider"></div>
				<div id="navlabel"></div>
				<div id="navigator"></div>
			</div>
			<div id="movie">
			</div>
			<div id="expand">
				<div id="leftbuttons">
					Picture area:
					<button id="expandlink" title="Expand left pane">Expand &gt;&gt;</button>
					Size:
					<button id="smalllink" class="sizebutton" title="Small thumbs - μικρές μικρογραφίες">Small</button>
					<button id="normallink" class="sizebutton" title="Large thumbs - μεγάλες μικρογραφίες">Large</button>
				</div>
				Group by:
				<button id="groupNoGroup" class="groupbutton" title="No Group">No Group</button>
				<button id="groupDirectors" class="groupbutton" title="Group Directors">Directors</button>
				<button id="groupCategories" class="groupbutton" title="Group Categories">Categories</button>
				<button id="groupCountries" class="groupbutton" title="Group Countries">Countries</button>
				<button id="groupYears" class="groupbutton" title="Group Years">Years</button>
				<button id="groupRatings" class="groupbutton" title="Group Ratings">Ratings</button>
				<button id="groupDates" class="groupbutton" title="Group Dates">Dates</button>
				<button id="groupMedia" class="groupbutton" title="Group Media">Media</button>
				<div id="admin" style="<?php echo $hidden; ?>">
					<button id="reload" style="<?php echo $hidden; ?>" title="Reload data">Reload</button>
					<button id="editMovie" title="Edit Movie">Edit</button>
					<button id="saveChanges" title="Save Changes">Save</button>
					<button id="makethumb" title="Recreate thumbnail">Thumb</button>
				</div>
			</div>
		</div>
	</body>
</html>