function isNumber(o) {
	return !isNaN(o - 0);
}

function getMovie(source) {
	var hreq = new Request.HTML({
		url: source,
		update: $('movie'),
		onRequest: function() {
//						console.log(source + ' requested' );
			$('movie').set('text', '').addClass('loading');
		},
		onComplete: function() {
			$('movie').removeClass('loading');
			$$('#details a.similar').each(function(item) {
				item.addEvent('click', function(event) {
					event.stop();
					getMovies(item.getProperty('href'), this.get('text'));
				});
			});
			contractLeft();
		}
	});
	hreq.send();

}

function getAll(source, label) {
	var hreq = new Request.HTML({
		url: source,
		update: $('navigator'),
		onRequest: function() {
//						console.log(source + ' requested' );
			$('navigator').set('text', '').addClass('loading');
			$('navlabel').setStyle('display', 'none');
		},
		onComplete: function() {
			$('navigator').removeClass('loading');

			$('list').removeClass('show');
			$('slider').removeClass('show');

			resize();

			$('navigator').removeEvents('click:relay(a)'); //important 
			$('navigator').addEvent('click:relay(a)', function(event, target) {
				event.preventDefault();
				event.stop();
				getMovie(target.getProperty('href'));
			});

			$$('#navigator a.grouplink').each(function(item) {
				item.removeEvents('click');
				item.addEvent('click', function(event) {
					event.preventDefault();
					event.stop();
					getMovies(this.get('href'), this.get('text'));
				});
			});
			//get count			
			var query = (source.indexOf('?') === -1) ? '?count' : '&count';
			hreq2 = new Request({
				url: source + query,
				method: 'get',
				onSuccess: function(response) {
					$('navlabel').set('text', $('navlabel').get('text') + ' (' + response + ')').setStyle('display', 'block');
				}
			});
			hreq2.send();
			$('label').setStyle('display', 'none');
			$('navlabel').set('text', label).setStyle('display', 'block');
			
			if (expandAfterLoad) expandLeft();
		}
	});
	hreq.send();
}

function getMovies(source, label) {
	var hreq = new Request.HTML({
		url: source,
		update: $('navigator'),
		onRequest: function() {
//						console.log(source + ' requested' );
			$('navigator').set('text', '').addClass('loading');
			$('navlabel').setStyle('display', 'none');
		},
		onComplete: function() {
			$('navigator').removeClass('loading');

			$('navigator').removeEvents('click:relay(a.movielink)');
			$('navigator').addEvent('click:relay(a.movielink)', function(event, target) {
				event.preventDefault();
				event.stop();
				getMovie(target.getProperty('href'));
			});

			$$('#navigator a.grouplink').each(function(item) {
				item.removeEvents('click');
				item.addEvent('click', function(event) {
					event.preventDefault();
					event.stop();
					getMovies(this.get('href'), this.get('text'));
				});
			});
			//get count
			var query = (source.indexOf('?') === -1) ? '?count' : '&count';
			hreq2 = new Request({
				url: source + query,
				method: 'get',
				onSuccess: function(response) {
					$('navlabel').set('text', $('navlabel').get('text') + ' (' + response + ')').setStyle('display', 'block');
				}
			});
			hreq2.send();
			if (isNumber(label))
				label = Math.round(label);
			$('navlabel').set('text', label).setStyle('display', 'block');
			
			if (expandAfterLoad) expandLeft();
		}
	});
	hreq.send();
}

function getList(source, label) {
	var hreq = new Request.HTML({
		url: source,
		update: $('list'),
		onRequest: function() {
//						console.log(source + ' requested' );
			$('list').removeClass('show');
			$('list').set('text', '').addClass('loading show');
		},
		onComplete: function() {
			var l = $('list');
			l.removeClass('loading');
			l.setStyle('height', 0);
			if (l.getScrollSize().y < 145) {
				l.setStyle('height', l.getScrollSize().y);
			} else {
				l.setStyle('height', 145);
			}
			$('slider').addClass('show');

			resize();

			$('list').removeEvents('click:relay(a)'); //important
			$('list').addEvent('click:relay(a)', function(event, target) {
				event.stop();
				getMovies(target.getProperty('href'), target.get('text'));
			});
			$('label').set('text', label).setStyle('display', 'inline');
			
			if (expandAfterLoad) expandLeft();
		}
	});
	hreq.send();
}

function makeThumb(thumb, title) {
	if (confirm('Recreate thumbnail of "' + title + '"')) {
		var src = thumb.getProperty('src');
		//get rid of query string if any
		var pos = src.indexOf('?');
		if (pos >= 0) {
			src = src.substr(0, pos);
		}
		;
		//request
		var hrec = new Request({
			url: 'recreateThumb.php?picture=' + src,
			onComplete: function() {
//							console.log('recreate complete');
			},
			onSuccess: function() {
//							console.log('recreate success');
			}
		});
		hrec.send();
		//reload image
		var date = new Date();
		thumb.setProperty('src', thumb.getProperty('src') + '?v=' + date.getTime());
	}
}
function contractLeft() {
	$('leftpane').removeClass('fullwidth');
	$('movie').removeClass('hide');
	$('expandlink').set('html', 'Expand &gt;&gt;').setProperty('title', 'Expand');
	if ($('content')) {
		$('makethumb').addClass('visible');
		$('editMovie').addClass('visible');
	} else {
		$('makethumb').removeClass('visible');
		$('editMovie').removeClass('visible');
	}
}
function expandLeft() {
	$('leftpane').addClass('fullwidth');
	$('movie').addClass('hide');
	$('expandlink').set('html', 'Contract &lt;&lt;').setProperty('title', 'Contract');
	$('makethumb').removeClass('visible');
	$('editMovie').removeClass('visible');

}

function toggleLeft() {
	if ($('expandlink').get('html').substring(0, 1) === 'E') {
		expandLeft();
	} else {
		contractLeft();
	}
}

function displayHelp(source) {
	var hreq = new Request.HTML({
		url: source,
		update: $('movie'),
		onRequest: function() {
//						console.log(source + ' requested' );
			$('movie').set('text', '').addClass('loading');
		},
		onComplete: function() {
			$('movie').removeClass('loading');
			$$('#stats a').each(function(item) {
				item.addEvent('click', function(event) {
					event.stop();
					getMovies(item.getProperty('href'), item.getProperty('text'));
				});
			});
			contractLeft();
		}
	});
	hreq.send();
}

window.addEvent('domready', function() {
	//menus
	$$('#menu a.tonav').each(function(item) {
		item.addEvent('click', function(event) {
			event.stop();
			getList(item.getProperty('href'), this.getProperty('rel'));
		});
	});
	$$('#menu a.all').each(function(item) {
		item.addEvent('click', function(event) {
			event.stop();
			getAll(item.getProperty('href'), this.getProperty('rel'));
		});
	});
	//help
	$('menuHelp').addEvent('click', function(event) {
		if (event && event.stop)
			event.stop(); //important for fireevent
		displayHelp(this.getProperty('href'));
	});
	//display help
	$('menuHelp').fireEvent('click');
	//search
	$('searchbutton').addEvent('click', function(event) {
		event.stop();
		if ($('searchstring').get('value').length > 0)
			getMovies($('searchform').getProperty('action') + '?search=' +
					$('searchstring').get('value') + '&where=' + $('where').get('value'),
					$('searchstring').get('value'));
	});
	//links to details
	$$('#navigator .movie a').each(function(item) {
		item.addEvent('click', function(event) {
			event.stop();
			getMovie(this.getProperty('href'));
		});
	});
	//footer expand link
	$('expandlink').addEvent('click', function(event) {
		event.stop();
		toggleLeft();
	});
	//footer picture size
	$('normallink').addEvent('click', function(event) {
		event.stop();
		$$('#navigator .movie').removeClass('smallMovie');
		$$('#navigator .movie img').removeClass('smallImg');
		$$('#navigator .movie .caption').removeClass('smallCaption');
		var myCookie = Cookie.write('large', true);
		$$('button.sizebutton').removeClass('selected');
		$('normallink').addClass('selected');
	});
	$('smalllink').addEvent('click', function(event) {
		event.stop();
		$$('#navigator .movie').addClass('smallMovie');
		$$('#navigator .movie img').addClass('smallImg');
		$$('#navigator .movie .caption').addClass('smallCaption');
		$$('button.sizebutton').removeClass('selected');
		$('smalllink').addClass('selected');
		var myCookie = Cookie.write('large', false);
	});
	//makethumb
	$('makethumb').addEvent('click', function(event) {
		event.stop();
		makeThumb($$('#movie #picture img')[0], $$('#movie #title h2 #maintitle').get('text')[0]);
	});
	//footer edit movie
	$('editMovie').addEvent('click', function(event) {
		event.stop();
		var index = $('index').get('text');
		var hreq = new Request.HTML({
			url: 'editMovie.php?index=' + index,
			update: $('movie'),
			onRequest: function() {
				$('movie').set('text', '').addClass('loading');
			},
			onComplete: function() {
				$('movie').removeClass('loading');
			}
		});
		hreq.send();
	});
	//footer save changes
	$('saveChanges').addEvent('click', function(event) {
		event.stop();
		var hreq = new Request({
			url: 'saveChanges.php',
			onRequest: function() {
//							console.log('requesting save');
				$('saveChanges').set('text', 'Wait');
			},
			onComplete: function() {
				Cookie.write('dirty', false);
				$('saveChanges').set('text', 'Save').removeClass('visible');
			}
		});
		hreq.send();
	});
	//reload
	$('reload').addEvent('click', function(event) {
		event.stop();
		if (confirm('Ready to reload data. Are sure?')) {
			var hreq = new Request({
				url: 'eraseLists.php',
				onRequest: function() {
//								console.log('requesting reload');
					$('reload').set('text', 'Wait');
				},
				onComplete: function() {
					location.reload(true);
				}
			});
			hreq.send();
		}
	});
	//footer grouping buttons
	$$('button.groupbutton').each(function(item) {
		item.addEvent('click', function(event) {
			event.stop();
			var myCookie = Cookie.write('group', item.get('text'));
			$$('button.groupbutton').removeClass('selected');
			this.addClass('selected');
		});
	});

	if (Cookie.read('dirty').toInt())
		$('saveChanges').addClass('visible');
	if (!Cookie.read('fresh').toInt()) {
		$('header').addClass('saved');
	}
	//preset footer picture size buttons
	var c = Cookie.read('large');
//				console.log(c);
	if (c == 'true')
		$('normallink').addClass('selected');
	else
		$('smalllink').addClass('selected');
	//preset footer group buttons
	c = Cookie.read('group');
//				console.log(c);
	if (c == 'No Group' || c == null) {
		$('groupNoGroup').addClass('selected');
	} else {
		$('group' + c).addClass('selected');
	}
	addSlider();
	resize();
});
//resizing window
timer = function() {
};
resize = function() {
	$clear(timer);
	timer = (function() {
		$('container').setStyle('height', window.getSize().y - $('container').getPosition().y - 15 + 'px');
		$('navigator').setStyle('height', $('container').getSize().y -
				$('navigator').getPosition().y -
				$('expand').getSize().y + 'px');
		$('movie').setStyle('height', $('navigator').getSize().y + $('list').getSize().y);
	}).delay(300);
};
window.addEvent('resize', function() {
	resize();
});
//prevent window unload if dirty
window.onbeforeunload = confirmExit;
function confirmExit() {
	if (Cookie.read('dirty').toInt()) {
		return "You have changes. Save before closing";
	}
}

addSlider = function() {
	var s = 0;
	new Drag($('list'), {
		handle: $('slider'),
		limit: {y: [30, 500]},
		snap: 5,
		modifiers: {x: false, y: 'height'},
		preventDefault: true,
		onComplete: function() {
			resize();
		},
		onSnap: function(el) {
			s = el.getScrollSize().y - 12;
		},
		onDrag: function(el) {
//						if (el.getSize().y > s) {
//							this.stop();
//							resize();
//						}
		}
	});
};

expandAfterLoad = false;