<?php
error_reporting(E_ERROR || E_WARNING);
ini_set('display_errors', '1');

$index = $_GET['index'];

require_once 'parserNew.php';
require_once 'thumbs.php';

// displays the stars for the rating

$pic = $_SESSION['lists']->Movies[$index]->moviePicture;

function rating($value) {
	$string = "";
	for ($i = 1; $i <= round($value); $i++) {
		$string .= "<img src=\"gfx/goldstar.gif\" alt=\"star\" />";
	}
	while ($i <= 10) {
		$string .= "<img src=\"gfx/greystar.gif\" alt=\"star\" />";
		$i++;
	}
	return $string;
}

function makeLinks($string, $type) {
	$result = "";
	$tempList = explode(',', $string);
	foreach ($tempList as $name) {
		$name = trim($name);
		$result .= "<a class=\"similar\" href=\"movies.php?name={$name}&item={$type}\">" . trim($name) . "</a>, ";
	}
	return substr($result, 0, -2);
}

function printMovie($index) {
	global $lists;
	$m = $lists->Movies[$index];
	$directorLinks = makeLinks($m->movieDirector, 'movieDirector');
	$actorLinks = makeLinks($m->movieActors, 'movieActors');
	$categoryLinks = makeLinks($m->movieCategory, 'movieCategory');
	$countryLinks = makeLinks($m->movieCountry, 'movieCountry');
	$yearLinks = makeLinks($m->movieYear, 'movieYear');
	$stars = rating($m->movieRating);
	$ratingLink = makeLinks($m->movieRating, 'movieRating');
	$dateLink = makeLinks($m->movieDate, 'movieDate');
	$mediaTypeLink = makeLinks($m->movieMediaType, 'movieMediaType');
	$p = new pic($m->moviePicture);
	$p->makeThumb();
	$thumb = $p->thfile;
	$caption = $m->movieFormattedTitle;

	//TODO enable change of seen flag while viewing movie. No need to go to edit
//	$seen = $m->movieSeen === 'True' ? "Seen" : "";
	$checked = $m->movieSeen ? 'checked' : '';
	if (ip_is_private($_SERVER['REMOTE_ADDR']))
		$seen = "<form id=\"seenform\" action=\"updateSeen.php\">
		<input type=\"hidden\" name=\"index\" value=\"$index\" />
		Seen <input type=\"checkbox\" name=\"seenbox\" id=\"seenbox\"" . $checked . ' /></form>';
	else
		$seen = $m->movieSeen ? "Seen" : "";
	$copyButton = (substr($m->movieLocation, 0, 1) == '\\') ? '<button id="copybutton">Copy to clipboard</button><span id="copied"></span>' : "";

	$otherTitle = (strlen($m->movieTranslatedTitle) > 0) ? "<dt>Other Title</dd>\n<dd>$m->movieTranslatedTitle</dd>" : "";
	$comments = (strlen($m->movieComments) > 0) ? "<dt>Comments</dd>\n<dd>$m->movieComments</dd>" : "";
	echo <<<END
   <div id="title">
   <h2><span id="maintitle" title="{$m->movieFormattedTitle}">{$m->movieOriginalTitle}</span> <span id="subtitle">$m->movieYear</span>
	</h2>
	</div>
	<span id="index" style="display:none">$index</span>
	<a><img id="fullpic" title="Click for details" alt="" /></a>
	<div id="content">
		<div id="picture">
			<a id="piclink" title="Click for full picture" href="#"><img src="$thumb" alt="" /></a>
		</div>
		<div id="details">
		   <div id="seenflag" class="$checked">$seen</div>
			<dl>
				<dt>Rating</dt>
					<dd>$stars $ratingLink</dd>
				$otherTitle
				<dt>Director</dd>
					<dd>$directorLinks</dd>
				<dt>Coutry / Year / Duration</dt>
					<dd>$countryLinks / $yearLinks / $m->movieLength mins</dd>
				<dt>Category</dt>
					<dd>$categoryLinks</dd>
				<dt>Actors</dt>
					<dd>$actorLinks</dd>
				<dt>URL</dt>
					<dd><a href="$m->movieURL" target="_blank">$m->movieURL</a></dd>
				<dt>Languages / <strong>Subtitles</strong></dt>
					<dd>$m->movieLanguages / <strong>$m->movieSubtitles</strong></dd>
				<dt>Description</dt>
					<dd>$m->movieDescription</dd>
				$comments
				<dt>Date / Location $copyButton</dt>
					<dd>$dateLink / <span id="location" class="high">$m->movieLocation</span></dd>
				<dt>MediaType / Format / Bitrate / Resolution / Framerate</dt>
					<dd>
						<strong>$mediaTypeLink</strong> / <strong>$m->movieVideoFormat</strong> /
						$m->movieVideoBitrate kbps / $m->movieResolution / $m->movieFramerate fps
					</dd>
				<dt>Audio / Bitrate</dt>
					<dd>$m->movieAudioFormat / $m->movieAudioBitrate kbps</dd>
				<dt>File Size / Disks</dt>
					<dd>$m->movieSize kb / $m->movieDisks</dd>
			</dl>
		</div>
	</div>

END;
}
?>
<!DOCTYPE html>
<html lang="en">
	<head>
		<title><?php echo $caption; ?></title>
		<meta charset="utf-8" />
		<meta http-equiv="X-UA-Compatible" content="IE=9" >
		<meta name="robots" content="index, follow" />
		<link rel="stylesheet" href="default.css" type="text/css" />
		<script type="text/javascript" src="//ajax.googleapis.com/ajax/libs/mootools/1.4.5/mootools-yui-compressed.js"></script>
		<script type="text/javascript" src="mootools-more-1.4.0.1.js"></script>
		<script src="mc/Source/MooClip.js"></script>
		<script type="text/javascript">
			window.addEvent('domready', function() {
				var clicked = false;
				$('piclink').addEvent('click', function(event) {
					event.stop();
					$('fullpic').setAttribute('src', '<?php echo $pic ?>');
					$('content').setStyle('display', 'none');
					$('fullpic').setStyle('display', 'block');
					//					$('fullpic').setStyle('max-width', $('content').getSize().x-1);
				});
				$('fullpic').addEvent('click', function(event) {
					event.stop();
					$('fullpic').setStyle('display', 'none');
//					$('fullpic').setAttribute('src', '<?php echo $pic ?>');
					$('content').setStyle('display', 'block');
				});
				//get rid of previous instances
				$$('div[id^=MooClipContainer]').dispose();
				doCopy = ($('location').get('text').substr(0, 1) === '\\');


				$('seenbox').addEvent('click', function() {
					console.log('clicked');
					console.log(this.get('checked'));
					var hreq = new Request({
						url: $('seenform').getProperty('action'),
						method: 'get',
						data: $('seenform'),
						onSuccess: function(responseText) {
							console.log('seen changed');
							Cookie.write('dirty', true);
							$('saveChanges').addClass('visible');
							//TODO the following code causes looping request
//							if (this.get('checked'))
//								$('seenflag').addClass('checked');
//							else
//								$('seenflag').removeClass('checked');

						},
						onRequest: function() {
							console.log('requesting updateSeen');
							console.log($('seenform').toQueryString());
						},
						onError: function() {
							console.log('error updateSeen');
						}
					});
					hreq.send();
				});
				$('seenbox').addEvent('mousedown', function() {
					console.log('mousedown');
				});
				$('seenbox').addEvent('change', function(event) {
					console.log('change');
				});
			});
		</script>
	</head>
	<body>
		<?php printMovie($index); ?>
		<script>
			if (doCopy) {
				new MooClip('#copybutton', {
					moviePath: 'mc/Source/ZeroClipboard.swf',
					dataSource: function() {
						return document.id('location').get('text');
					},
					onCopy: function() {
						$('copied').set('html', ' copied!');
					}
				});
			}
		</script>
	</body>
</html>