<?php
error_reporting(E_ALL);
ini_set('display_errors', '1');

require_once 'parserNew.php';
require_once 'thumbs.php';
//dbg($_GET);


if (isset($_GET[search])) {
//var_dump($_GET); die();
	$searchstring = strtoupper($_GET['search']);
	$where = $_GET['where'];
	if (strlen($where) == 0)
		$where = "movieFormattedTitle";
	$movies = &search($where, $searchstring);
//	dbg($movies);
} else {
	if (isset($_GET['item'])) {
		if ($_GET['item'] == "movieRating") {
			$list = getMovieListByRating($_GET['name']);
		} else {
			$list = getMovieList($_GET['name'], $_GET['item']);
		}
		$movies = array();
		foreach ($list as $index) {
			$movies[$index] = $lists->Movies[$index];
		}
	} else { //no item set
		$movies = $lists->Movies;
	}
}

if (isset($_GET['group'])) {
	$group = $_GET['group'];
} elseif (isset($_COOKIE['group'])) {
	if ($_COOKIE['group'] !== 'No Group')
		$group = $_COOKIE['group'];
}

function search($where, $searchstring) {
	global $lists;
	$movies = array();
	foreach ($lists->Movies as $key => $m) {
		if (strpos(strtoupper($m->{$where}), $searchstring) !== false) {
			$movies[$key] = $m;
		}
	}
	return $movies;
}

function cmpRating($a, $b) {
	if ($a->movieRating == $b->movieRating) {
		return 0;
	}
	return ((float) $a->movieRating < (float) $b->movieRating) ? -1 : 1;
}

function printMovies(&$movies) {
//	dbg($movies);
	if (isset($_COOKIE['large'])) {
		$movieClass = ($_COOKIE['large'] == 'true') ? '' : 'smallMovie';
		$imgClass = ($_COOKIE['large'] == 'true') ? '' : 'smallImg';
		$captionClass = ($_COOKIE['large'] == 'true') ? '' : 'smallCaption';
	} else {
		$movieClass = 'smallMovie';
		$imgClass = 'smallImg';
		$captionClass = 'smallCaption';
	}

	foreach ($movies as $key => $m) {
		$pic = $m->moviePicture;
		$p = new pic($pic);
		$p->owner = $owner;
		$p->group = $usergroup;
		
		$p->makeThumb();
		$thumb = $p->thfile;
		$caption = $m->movieFormattedTitle;
		echo "		<div class=\"movie $movieClass\">\n";
		echo "			<a href=\"movie.php?index=$key\" class=\"movielink\" >\n";
		echo "				<img class=\"$imgClass\" src=\"$thumb\" alt=\"$caption\" title=\"$caption\" />\n";
		echo "				<div class=\"caption $captionClass\" title=\"$caption\">\n";
		echo "					$caption\n";
		echo "				</div>\n";
		echo "			</a>\n";
		echo "		</div>\n";
	}
}

function printReport(&$movies, $group) {
	global $lists;
	$report = &makeReport($group);
	foreach ($report as $key => $value) {
		$groupMovies = array();
		foreach ($value as $m) {
			//check if movie is in list
			if (isset($movies[$m]))
				$groupMovies[$m] = $movies[$m];
		}
		if (count($groupMovies)) {
			$l = '?name=' . $key . '&item=' . $lists->associations[$group];
			$link = '<a class="grouplink" href="movies.php' . $l . '">' . $key . '</a>';
			echo "<div class=\"group\">\n<h3>$link</h3>\n<div class=\"content\">\n";
			printMovies($groupMovies);
			echo "\n</div>\n</div>\n";
		}
	}
}
//dbg($movies, false, "end");
if (isset($_GET['count'])) {
	echo count($movies); die();
}
?><!DOCTYPE html>
<html lang="en">
	<head>
		<title>ANT Movies</title>
		<meta charset="utf-8" />
		<meta http-equiv="X-UA-Compatible" content="IE=9" >		
		<meta name="robots" content="index, follow" />
		<link rel="stylesheet" href="default.css" type="text/css" />
	</head>
	<body>
		<?php
		if (count($movies) > 0) {
//			dbg(count($movies), false, "count");
//			dbg(isset($group), false, "groupset");
//			dbg($group, false, $group);
			if (isset($group)) {
				printReport($movies, $group);
			} else {
//				dbg($movies);
				printMovies($movies);
			}
		} else {
			echo "Nothing found!";
		}
		?>			
	</body>
</html>