<?php

error_reporting(E_ERROR || E_WARNING);
ini_set('display_errors', '1');

session_start();

include('config.php');
require_once 'functions.php';

class Movie {

// the data of each movie ase per ANT Movie Catalog
	public $movieNumber = "";
	public $movieMediaLabel = "";
	public $movieBorrower = "";
	public $movieDate = "";
	public $movieRating = "";
	public $movieOriginalTitle = "";
	public $movieTranslatedTitle = "";
	public $movieFormattedTitle = "";
	public $movieDirector = "";
	public $movieProducer = "";
	public $movieCountry = "";
	public $movieCategory = "";
	public $movieYear = "";
	public $movieLength = "";
	public $movieActors = "";
	public $movieURL = "";
	public $movieDescription = "";
	public $movieComments = "";
	public $movieVideoFormat = "";
	public $movieVideoBitrate = "";
	public $movieAudioFormat = "";
	public $movieAudioBitrate = "";
	public $movieResolution = "";
	public $movieFramerate = "";
	public $movieLanguages = "";
	public $movieSubtitles = "";
	public $movieSize = "";
	public $movieDisks = "";
	public $moviePicture = "";
	public $movieChecked = "";
	public $movieLocation = "";
	public $movieMediaType = "";
	public $movieColorTag = "";
	public $movieSeen = false;

	/**
	 * Replace <br /> and equivalent to | before writing to file
	 * this is required by ANT Movie Catalog
	 * 
	 * @param string $text
	 * @return string
	 */
	function prepText($text) {
		$needle = array("&lt;br /&gt;", "<br>", "<br />");
		$text = str_replace($needle, "|", $text);
		$text = str_replace("\n", "", $text);
		return $text;
	}

	public function writeXML(&$writer) {
		$writer->startElement('Movie');
			$writer->writeAttribute('Number', $this->movieNumber);
			$writer->writeAttribute('Checked', $this->movieChecked);
			$writer->writeAttribute('Date', $this->movieDate);
			$writer->writeAttribute('Rating', $this->movieRating);
			$writer->writeAttribute('OriginalTitle', $this->movieOriginalTitle);
			if (strlen($this->movieTranslatedTitle) > 0) $writer->writeAttribute('TranslatedTitle', $this->movieTranslatedTitle);
			$writer->writeAttribute('FormattedTitle', $this->movieFormattedTitle);
			if (strlen($this->movieDirector) > 0) $writer->writeAttribute('Director', $this->movieDirector);
			if (strlen($this->movieProducer) > 0) $writer->writeAttribute('Producer', $this->movieProducer);
			if (strlen($this->movieCountry) > 0) $writer->writeAttribute('Country', $this->movieCountry);
			if (strlen($this->movieCategory) > 0) $writer->writeAttribute('Category', $this->movieCategory);
			if (strlen($this->movieYear) > 0) $writer->writeAttribute('Year', $this->movieYear);
			if (strlen($this->movieLength) > 0) $writer->writeAttribute('Length', $this->movieLength);
			if (strlen($this->movieActors) > 0) $writer->writeAttribute('Actors', $this->movieActors);
			if (strlen($this->movieURL) > 0) $writer->writeAttribute('URL', $this->movieURL);
			if (strlen($this->movieDescription) > 0) $writer->writeAttribute('Description', $this->prepText($this->movieDescription));
			if (strlen($this->movieComments) > 0) $writer->writeAttribute('Comments', $this->prepText($this->movieComments));
			if (strlen($this->movieVideoFormat) > 0) $writer->writeAttribute('VideoFormat', $this->movieVideoFormat);
			if (strlen($this->movieVideoBitrate) > 0) $writer->writeAttribute('VideoBitrate', $this->movieVideoBitrate);
			if (strlen($this->movieAudioFormat) > 0) $writer->writeAttribute('AudioFormat', $this->movieAudioFormat);
			if (strlen($this->movieAudioBitrate) > 0) $writer->writeAttribute('AudioBitrate', $this->movieAudioBitrate);
			if (strlen($this->movieResolution) > 0) $writer->writeAttribute('Resolution', $this->movieResolution);
			if (strlen($this->movieFramerate) > 0) $writer->writeAttribute('Framerate', $this->movieFramerate);
			if (strlen($this->movieLanguages) > 0) $writer->writeAttribute('Languages', $this->movieLanguages);
			if (strlen($this->movieSubtitles) > 0) $writer->writeAttribute('Subtitles', $this->movieSubtitles);
			if (strlen($this->movieSize) > 0) $writer->writeAttribute('Size', $this->movieSize);
			if (strlen($this->movieDisks) > 0) $writer->writeAttribute('Disks', $this->movieDisks);
			$writer->writeAttribute('Picture', str_replace("/", "\\", $this->moviePicture));
			if (strlen($this->movieMediaType) > 0) $writer->writeAttribute('MediaType', $this->movieMediaType);
			if (strlen($this->movieColorTag) > 0) $writer->writeAttribute('ColorTag', $this->movieColorTag);
			$writer->startElement('CustomFields');
				$writer->writeAttribute('location', $this->movieLocation);
				if ($this->movieSeen) 
					$writer->writeAttribute('seen', "True");
			$writer->endElement();
		$writer->endElement(); //Movie
	}

}

class Lists {

	public $Directors = array();
	public $Actors = array();
	public $Categories = array();
	public $Countries = array();
	public $Movies = array();
	public $Years = array();
	public $Ratings = array(0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10);
	public $associations = array(
		"Directors" => 'movieDirector',
		"Actors" => 'movieActors',
		"Categories" => 'movieCategory',
		"Countries" => 'movieCountry',
		"Years" => 'movieYear',
		"Ratings" => 'movieRating',
		"Dates" => 'movieDate',
		"Media" => 'movieMediaType',
		"Resolution" => 'movieResolution',
		"Location" => 'movieLocation',
		"Seen" => 'movieSeen'
	);

}

$m = null;

/**
 * Replace | with <br /> in string
 * 
 * @param string $text
 * @return string
 */
function putbr($text) {
	return str_replace("|", "<br />", $text);
}

/**
 * startElement handler
 */
function startElement($parser, $name, $attr) {
	//TODO collect information from start of XML file for custom fields properties and each custom field
	//REASON XML file written does not render properly on AMC the "seen" field renders as string. The rest are OK
	global $m;
//	echo "Start: ", $name, "<br/>";
	//read all attributes
	if (strcmp($name, "Movie") == 0) {
		$m = new Movie();
		$m->movieNumber = $attr["Number"];
		$m->movieMediaLabel = $attr["MediaLabel"];
		$m->movieBorrower = $attr["Borrower"];
		$m->movieDate = $attr["Date"];
		$m->movieRating = $attr["Rating"];
		$m->movieOriginalTitle = $attr["OriginalTitle"];
		$m->movieTranslatedTitle = $attr["TranslatedTitle"];
		$m->movieFormattedTitle = $attr["FormattedTitle"];
		$m->movieDirector = $attr["Director"];
		$m->movieProducer = $attr['Producer'];
		$m->movieCountry = $attr["Country"];
		$m->movieCategory = $attr["Category"];
		$m->movieYear = $attr["Year"];
		$m->movieLength = $attr["Length"];
		$m->movieActors = $attr["Actors"];
		$m->movieURL = $attr["URL"];
		$m->movieDescription = putbr($attr["Description"]);
		$m->movieComments = putbr($attr['Comments']);
		$m->movieVideoFormat = $attr["VideoFormat"];
		$m->movieVideoBitrate = $attr["VideoBitrate"];
		$m->movieAudioFormat = $attr["AudioFormat"];
		$m->movieAudioBitrate = $attr["AudioBitrate"];
		$m->movieResolution = $attr["Resolution"];
		$m->movieFramerate = $attr["Framerate"];
		$m->movieLanguages = $attr["Languages"];
		$m->movieSubtitles = $attr["Subtitles"];
		$m->movieSize = $attr["Size"];
		$m->movieDisks = $attr["Disks"];
		$m->moviePicture = str_replace("\\", "/", $attr["Picture"]);
		$m->movieChecked = $attr["Checked"];
		$m->movieMediaType = $attr["MediaType"];
		$m->movieColorTag = $attr["ColorTag"];
	}
	if (strcmp($name, "CustomFields") == 0) {
		$m->movieLocation = $attr["location"];
		$m->movieSeen = ($attr["seen"] === "True") ? true : false;
	}
}

/**
 * endElement handler
 */
function endElement($parser, $name) {
	global $lists, $m;
//	echo "End: ", $name, "<br/>";
	if (strcmp($name, "Movie") == 0) {
		$lists->Movies[] = $m;
	}
}

/**
 * characterData handler
 */
function characterData($parser, $data) {
//	global $elements;
//
//	foreach ($elements as $element) {
//		if ($GLOBALS["currentElement"] == $element) {
//			$GLOBALS[$element] .= $data;
//		}
//	}
}

/**
 * parse function
 */
function parseFile() {
	global $xmlSource;

	/* Creating the xml parser */
	$xml_parser = xml_parser_create();

	/* Register the handlers */
	xml_set_element_handler($xml_parser, "startElement", "endElement");
//	xml_set_character_data_handler($xml_parser, "characterData");

	/* Disables case-folding. Needed for this example */
	xml_parser_set_option($xml_parser, XML_OPTION_CASE_FOLDING, false);

	/* Open the xml file and feed it to the parser in 4k blocks */
	if (!($fp = fopen($xmlSource, "r"))) {
		die("Cannot open  $xmlSource  ");
	}
	while (($data = fread($fp, 4096))) {
		if (!xml_parse($xml_parser, $data, feof($fp))) {
			die(sprintf("XML error at line %d column %d ", xml_get_current_line_number($xml_parser), xml_get_current_column_number($xml_parser)));
		}
	}

	/* Finish ! we free the parser and returns the array */
	xml_parser_free($xml_parser);

	return true;
}

/**
 * 
 * @global Lists $lists
 * @param string $file
 */
function writeXML($file) {
	//TODO output custom fields properties collected from function startElement
	global $lists;
	usort($lists->Movies, cmpNumber);

	$writer = new XMLWriter();
	$writer->openURI($file);
	$writer->startDocument('1.0', 'windows-1253');
		$writer->setIndent(4);
		$writer->startElement('AntMovieCatalog');
			$writer->writeAttribute('Format', '41');
			$writer->writeAttribute('Version', '4.1.2 (2013-02-10');
			$writer->writeAttribute('Date', date('j/n/Y G:i:s'));
			$writer->startElement('Catalog');
				$writer->startElement('Properties');
				$writer->endElement();
				$writer->startElement('CustomFieldsPropoerties');
					$writer->writeAttribute('ColumnSettings', 'location:p34:w334:vt,seen:p35:w120:vt,');
					$writer->writeAttribute('GUIProperties', 'fw382:fh882');
					$writer->startElement('CustomField');
						$writer->writeAttribute('Tag', 'location');
						$writer->writeAttribute('Name', 'Location');
						$writer->writeAttribute('Type', 'ftString');
						$writer->writeAttribute('GUIProperties', 'rx6:ry3:rw526:rh25:aw1:ah0:lw94');
					$writer->endElement(); //CustomField
					$writer->startElement('CustomField');
						$writer->writeAttribute('Tag', 'seen');
						$writer->writeAttribute('Name', 'seen');
						$writer->writeAttribute('Type', 'ftBoolean');
						$writer->writeAttribute('GUIProperties', 'rx6:ry27:rw526:rh25:aw1:ah0:lw94');
					$writer->endElement(); //CustomField
				$writer->endElement(); //CustomFieldsProperties
				$writer->startElement('Contents');
					foreach ($lists->Movies as $m) {
						$m->writeXML($writer);
					}
				$writer->endElement(); //Contents
		$writer->endElement(); //Catalog
	$writer->endElement(); //AntMovieCatalog
$writer->endDocument();
$writer->flush();

	usort($lists->Movies, cmpTitle);
}

/**
 * Make list of e.g Actors, Categories, Countries, Directors
 * e.g. makeList('movieDirector');
 * NOTE: called once for each list
 *
 * @global Lists $lists
 * @param string $item the name of the corresponding property of a movie object
 *
 * @return array of $item from all movies
 */
function makeList($item) {
	global $lists;
	$tempList = array();
	foreach ($lists->Movies as $m) {
		$temp = explode(',', $m->{$item});
		foreach ($temp as $t) {
			$t = trim($t);
			if (strlen($t) > 0)
				$tempList[] = trim($t);
		}
	}
	$tempList = array_values(array_unique($tempList));
	sort($tempList);
	return $tempList;
}

function makeResolutionList() {
	global $lists;
	$tempList = array();
	foreach ($lists->Movies as $m) {
		$temp = explode('x', $m->movieResolution);
		$tempList[] = trim($temp[0]);
	}
	$tempList = array_values(array_unique($tempList));
	sort($tempList);
	if (strlen(trim($tempList[0])) == 0) 
		unset($tempList[0]);
	return $tempList;
}

function getServer($location) {
	$l = strpos($location, '\\', 2);
	return substr($location, 2, $l - 2);	
}

function makeLocationList() {
	global $lists;
	$tempList = array();
	foreach ($lists->Movies as $m) {
		$temp = (substr($m->movieLocation, 0, 1) == '\\') ? getServer($m->movieLocation) : trim($m->movieLocation);
		$tempList[] = trim($temp);
	}
	$tempList = array_values(array_unique($tempList));
	sort($tempList);
	if (strlen(trim($tempList[0])) == 0) 
		unset($tempList[0]);
	return $tempList;	
}
/**
 * get a list of movie indexes of films containing $name in $item
 * e.g. getMovieList("Woody Allen", "movieActors")
 *
 * @global Lists $lists
 * @param string $name actual string searching for e.g. "Woody Allen"
 * @param string $item item to search e.g. "movieActors" i.e. the corresponding property name of a movie object
 *
 * @return array of movie indexes
 */
function getMovieList($name, $item) {
	global $lists;
	$movieList = array();
	$i = 0;
	switch ($item) {
		case 'movieMediaType':
			foreach ($lists->Movies as $m) {
				if ($m->{$item} === $name) {
					$movieList[] = $i; //. " " . $lists->Movies[$i]->movieOriginalTitle;
				}
				$i++;
			}
			break;
		default:
			foreach ($lists->Movies as $m) {
				if (strpos($m->{$item}, $name) !== false) {
					$movieList[] = $i; //. " " . $lists->Movies[$i]->movieOriginalTitle;
				}
				$i++;
			}
	}

	return $movieList;
}

function getMovieListByRating($rating) {
	global $lists;
	$movieList = array();
	$i = 0;
	$rating = round($rating);
	foreach ($lists->Movies as $m) {
		if ($rating == round($m->movieRating)) {
			$movieList[] = $i; //. " " . $lists->Movies[$i]->movieOriginalTitle;
		}
		$i++;
	}
	return $movieList;
}

/**
 *
 * @global Lists $lists
 * @param string $listName the name of the list to use. Property of $lists, e.g. "Actors"
 *
 * @return associative array name => movielist
 */
function makeReport($listName) {
	global $lists;
	$item = $lists->associations[$listName];
	$report = array();
	foreach ($lists->{$listName} as $name) {
		$movieList = ($listName == 'Ratings') ? getMovieListByRating($name) : getMovieList($name, $item);
		$report[$name] = $movieList;
	}
	return $report;
}

function cmpTitle($a, $b) {
	if ($a->movieOriginalTitle == $b->movieOriginalTitle) {
		return 0;
	}
	return (strcmp($a->movieOriginalTitle, $b->movieOriginalTitle) < 0) ? -1 : 1;
}

function cmpNumber($a, $b) {
	if ($a->movieNumber === $b->movieNumber) {
		return 0;
	}
	return (strcmp(sprintf('%04d', $a->movieNumber), sprintf('%04d', $b->movieNumber)) < 0) ? -1 : 1;
}
/**
 * 
 * @global Lists $lists
 * @param string $list
 * @return array
 */
function stats($list) {
	global $lists;
	$tempList = array();
	$item = $lists->associations[$list]; //get property to use
	
	//initialise
	foreach ($lists->{$list} as $l) {
		$tempList[$l] = 0;
	}
	
	foreach ($lists->Movies as $m) {
		$temp = explode(',', $m->{$item});
		foreach ($temp as $t) {
			$t = trim($t);
			if (strlen($t) > 0)
				$tempList[$t] += 1;
		}
	}
	
	unset($tempList['(more)']);
	arsort($tempList);
	return $tempList;
}

function statsRatings($list) {
	global $lists;
	$tempList = array();
	$item = $lists->associations[$list];
	
	foreach ($lists->{$list} as $l) {
		$tempList[$l] = 0;
	}
	
	foreach ($lists->Movies as $m) {
		$temp = round($m->{$item});
		$tempList[$temp] +=1;
	}
	
	arsort($tempList);
	return $tempList;
	
}

function statsResolution($list) {
	global $lists;
	$tempList = array();
	$item = $lists->associations[$list];
	
	foreach ($lists->{$list} as $l) {
		$tempList[$l] = 0;
	}
	
	foreach ($lists->Movies as $m) {
		$temp = explode('x', $m->{$item});
		if (strlen($temp[0]) > 0) $tempList[$temp[0]] +=1;
	}
	//get rid of smaller resolutions
	foreach ($tempList as $key => $value) {
		if ((int) $key < 700) unset($tempList[$key]);
	}
	
	arsort($tempList);
	return $tempList;
	
}

function statsLocation($list) {
	global $lists;
	$tempList = array();
	$item = $lists->associations[$list];
	
	foreach ($lists->{$list} as $l) {
		$tempList[$l] = 0;
	}
	
	foreach ($lists->Movies as $m) {
		$temp = (substr($m->movieLocation, 0, 1) == '\\') ? getServer($m->movieLocation) : trim($m->movieLocation);
		if (strlen($temp[0]) > 0) $tempList[$temp] +=1;
	}
	
	arsort($tempList);
	return $tempList;
	
}

function statsSeen($list) {
	global $lists;
	$tempList = array();
	$item = $lists->associations[$list]; //movieSeen
	
	foreach ($lists->{$list} as $l) {
		$tempList[$l] = 0;
	}
	
	foreach ($lists->Movies as $m) {
		$tempList[$m->{$item}] += 1;
	}
	
	return $tempList;
}

function init() {
	global $lists;
	if (!isset($_SESSION['lists'])) {
		//read and create new data lists
		$lists = new Lists();
		//read xml file
		parseFile();
		//sort alphabetically
		usort($lists->Movies, cmpTitle);
		//Make lists and
		//get rid of element "(more)" from lists
		$lists->Actors = &makeList("movieActors");
		unset($lists->Actors[array_search('(more)', $lists->Actors)]);

		$lists->Categories = &makeList("movieCategory");
		unset($lists->Categories[array_search('(more)', $lists->Categories)]);

		$lists->Countries = &makeList("movieCountry");
		unset($lists->Countries[array_search('(more)', $lists->Countries)]);

		$lists->Directors = &makeList("movieDirector");
		unset($lists->Directors[array_search('(more)', $lists->Directors)]);

		$lists->Years = &makeList("movieYear");

		$lists->Dates = &makelist("movieDate");
		$lists->Media = &makelist("movieMediaType");
		$lists->Resolution = &makeResolutionlist();
		$lists->Location = &makeLocationlist();
		$lists->Seen = &makeList("movieSeen");
		
		//keep lists in SESSION
		$_SESSION['lists'] = $lists;

		$_SESSION['dirty'] = 0;
		setcookie('dirty', 0);

		$_SESSION['fresh'] = 1; //fresh reading and lists
		setcookie('fresh', 1);
	} else {

		//get lists from SESSION
		$lists = $_SESSION['lists'];
		//set dirty flag
		setcookie('dirty', $_SESSION['dirty']);

		$_SESSION['fresh'] = 0; //this is not a fresh reading
		setcookie('fresh', 0);
	}
}

init();

// for testing only //
//echo "<pre>";
//print_r($lists->Movies);
//print_r($lists->Actors);
//print_r($lists->Categories);
//print_r($lists->Countries);
//print_r($lists->Directors);
//to be used to create reports
//print_r(makeReport('Actors'));
//print_r(makeReport('Categories'));
//print_r(makeReport('Countries'));
//print_r(makeReport('Directors'));
//print_r(makeReport('Years'));
//
//echo "</pre>";
// end test //
//writeXML();
//echo 'done';
//dbg(stats('Categories'));
//dbg(stats('Years'));
//dbg(stats('Directors'));
//dbg(stats('Ratings'));
?>