<?php

define('SIZE', 100);

class pic {

	public $sizex;
	public $sizey;
	public $imagetype;
	public $mime;
	var $im;  //original image object
	var $th;  //thumb image object
	public $file;  //original file
	public $thfile; //thumb file;
	public $thdir;  //thumb dir;
	public $thsizex;  //
	public $thsizey;
	public $owner;
	public $group;

	function __construct($file) {
		$s = getimagesize($file);
//			var_dump($s);
		$this->sizex = $s[0];
		$this->sizey = $s[1];
//			$this->maxxy = ($this->sizex > $this->sizey) ? $this->sizex : $this->sizey; //maximum dimension
		$this->imagetype = $s[2];
		$this->mime = $s['mime'];
		$this->file = $file;

		$p = pathinfo($file);
		$this->thdir = $p['dirname'] . "/Thumbs";
		$this->thfile = $p['dirname'] . "/Thumbs/" . $p['filename'] . "." . $p['extension'];
	}

	function loadPicture() {
		$this->im = imagecreatefromjpeg($this->file);
	}

	function unloadPicture() {
		imagedestroy($this->im);
	}

	function filter($filter, $level) {
		if (is_null($this->im))
			$this->loadPicture();
		switch ($filter) {
			case 'bw':
				$f = IMG_FILTER_GRAYSCALE;
				break;
			case 'edge':
				$f = IMG_FILTER_EDGEDETECT;
				break;
			case 'bright':
				$f = IMG_FILTER_BRIGHTNESS;
				break;
			case 'contrast':
				$f = IMG_FILTER_CONTRAST;
				break;
			case 'blur':
				$f = IMG_FILTER_GAUSSIAN_BLUR;
				break;
			case 'mean':
				$f = IMG_FILTER_MEAN_REMOVAL;
				break;
			case 'negative':
				$f = IMG_FILTER_NEGATE;
				break;
			case 'pixel':
				$f = IMG_FILTER_PIXELATE;
				break;
		}
		if ($filter <> '')
			imagefilter($this->im, $f, $level);
	}

	function makeThumb($force = false) {
		if (!file_exists($this->thfile) or $force) {
			$this->loadPicture();
			$this->saveThumb();
		} else {
			$s = getimagesize($this->thfile);
			$this->thsizex = $s[0];
			$this->thsizey = $s[1];
		}
	}

	function saveThumb() {

		if ($this->sizex > $this->sizey) { //x>y
			$sx = round(SIZE * ($this->sizex / $this->sizey));
			$sy = SIZE;
		} else {
			if ($this->sizex == $this->sizey) {
				$sx = SIZE;
				$sy = SIZE;
			} else { //y>x
				$sy = round(SIZE * ($this->sizey / $this->sizex));
				$sx = SIZE;
			}
		}
		$this->th = ImageCreateTrueColor($sx, $sy);
		if (is_null($this->im))
			loadPicture();
		imagecopyresampled($this->th, $this->im, 0, 0, 0, 0, $sx, $sy, $this->sizex, $this->sizey);

		if (!file_exists($this->thdir)) {
			mkdir($this->thdir, 0777);
			if (strlen($this->owner) > 0) {
				chown($this->thdir, $this->owner);
				chgrp($this->thdir, $this->group);
			}
		} else {
			
		}
		imagejpeg($this->th, $this->thfile);
		chmod($this->thfile, 0666);

		if (strlen($this->owner) > 0) {
			chown($this->thfile, $this->owner);
			chgrp($this->thfile, $this->group);
		}

		//NOTE Added on 14/11/12
		$this->thsizex = $sx;
		$this->thsizey = $sy;
		//end
	}

	function serve() {
		header("Content-Type: " . $this->mime);
		if (is_null($this->im))
			$this->loadPicture();
		imagejpeg($this->im);
	}

}

/**
 * Makes square thumbnails
 */
class squareThumb {

	var $opic; //pic object
	var $oth; //thumb pic object;
	var $sth; //square image object
	var $size;  //smaller dimension of thumb, the size of the square to be produced;

	function __construct($file) {
		$this->opic = new pic($file);
		$this->opic->makeThumb(); //make thumb if not exists

		$this->oth = new pic($this->opic->thfile); //make picture object of thumb
		$this->size = min($this->oth->sizex, $this->oth->sizey);
		$this->oth->loadPicture();
	}

	/**
	 * Returns raw square thumb ready for display
	 */
	function getSquare() {
		$this->sth = imagecreatetruecolor($this->size, $this->size); //new square thumb image object
		if ($this->oth->sizex > $this->oth->sizey) { //x>y
			$sx = ($this->oth->sizex - $this->oth->sizey) / 2;
			$sy = 0;
		} else {
			if ($this->oth->sizex == $this->oth->sizey) {
				$sx = 0;
				$sy = 0;
			} else { //y>x
				$sy = ($this->oth->sizey - $this->oth->sizex) / 2;
				$sx = 0;
			}
		}
		imagecopy($this->sth, $this->oth->im, 0, 0, $sx, $sy, $this->size, $this->size);
		header("Content-type: {$this->oth->mime}");
		imagejpeg($this->sth);
	}

}

function serveImage($file, $filter, $level) {
	$p = new pic($file);
	$fs = explode(',', $filter);
	foreach ($fs as $f) {
		$p->filter($f, $level);
	}
	$p->serve();
	$p->unloadPicture();
}

if (isset($_GET['file'])) {
	serveImage($_GET['file'], $_GET['filter'], $_GET['level']);
}
?>